Skip to content
Start here

List OAuth Clients

iam.oauth_clients.list(OAuthClientListParams**kwargs) -> SyncSinglePage[OAuthClientListResponse]
GET/accounts/{account_id}/oauth_clients

List all OAuth clients for an account.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
OAuth Client Read
ParametersExpand Collapse
account_id: str

Account identifier tag.

maxLength32
minLength32
ReturnsExpand Collapse
class OAuthClientListResponse:

Fields shared by OAuth client responses and create/update requests.

client_id: str

The unique identifier for an OAuth client.

visibility: Literal["public", "private"]

Visibility of the OAuth client.

One of the following:
"public"
"private"
allowed_cors_origins: Optional[List[str]]

Array of allowed CORS origins.

client_name: Optional[str]

Human-readable name of the OAuth client.

client_uri: Optional[str]

URL of the home page of the client.

client_uri_verification: Optional[ClientURIVerification]

Client URI domain control verification state.

status: Optional[Literal["pending", "in_progress", "verified", "failed"]]

Current verification status for the client URI host.

One of the following:
"pending"
"in_progress"
"verified"
"failed"
text: Optional[str]

Exact TXT record value that must be added to DNS to prove ownership of the client URI host.

created_at: Optional[datetime]

Timestamp when the OAuth client was created.

formatdate-time
grant_types: Optional[List[Literal["authorization_code", "refresh_token"]]]

Array of OAuth grant types the client is allowed to use. authorization_code is required; refresh_token may be included optionally.

One of the following:
"authorization_code"
"refresh_token"
has_rotated_secret: Optional[bool]

Indicates whether the client has a rotated secret that has not yet been deleted.

logo_uri: Optional[str]

URL of the client’s logo.

policy_uri: Optional[str]

URL that points to a privacy policy document.

post_logout_redirect_uris: Optional[List[str]]

Array of allowed post-logout redirect URIs.

redirect_uris: Optional[List[str]]

Array of allowed redirect URIs for the client.

response_types: Optional[List[Literal["token", "id_token", "code"]]]

Array of OAuth response types the client is allowed to use.

One of the following:
"token"
"id_token"
"code"
scopes: Optional[List[str]]

Array of OAuth scopes the client is allowed to request. Colon-delimited scopes are not accepted. Dot-delimited scopes are validated against available OAuth API scopes; simple identity scopes are allowed. Protocol scopes offline_access and openid are added or removed automatically based on grant_types and response_types.

token_endpoint_auth_method: Optional[Literal["none", "client_secret_basic", "client_secret_post"]]

The authentication method the client uses at the token endpoint.

One of the following:
"none"
"client_secret_basic"
"client_secret_post"
tos_uri: Optional[str]

URL that points to a terms of service document.

updated_at: Optional[datetime]

Timestamp when the OAuth client was last updated.

formatdate-time

List OAuth Clients

import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
page = client.iam.oauth_clients.list(
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
)
page = page.result[0]
print(page.client_id)
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "client_id": "a1b2c3d4e5f6a1b2c3d4e5f6a1b2c3d4",
      "visibility": "private",
      "allowed_cors_origins": [
        "https://example.com"
      ],
      "client_name": "My OAuth App",
      "client_uri": "https://example.com",
      "client_uri_verification": {
        "status": "in_progress",
        "text": "cloudflare_oauth_client_publisher=example"
      },
      "created_at": "2025-01-01T00:00:00Z",
      "grant_types": [
        "authorization_code",
        "refresh_token"
      ],
      "has_rotated_secret": false,
      "logo_uri": "https://example.com/logo.png",
      "policy_uri": "https://example.com/privacy",
      "post_logout_redirect_uris": [
        "https://example.com/logout"
      ],
      "promoted_at": "2026-05-13T12:00:00Z",
      "redirect_uris": [
        "https://example.com/callback"
      ],
      "response_types": [
        "code"
      ],
      "scopes": [
        "account.read"
      ],
      "token_endpoint_auth_method": "client_secret_post",
      "tos_uri": "https://example.com/tos",
      "updated_at": "2025-01-01T00:00:00Z"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": [
    {
      "client_id": "a1b2c3d4e5f6a1b2c3d4e5f6a1b2c3d4",
      "visibility": "private",
      "allowed_cors_origins": [
        "https://example.com"
      ],
      "client_name": "My OAuth App",
      "client_uri": "https://example.com",
      "client_uri_verification": {
        "status": "in_progress",
        "text": "cloudflare_oauth_client_publisher=example"
      },
      "created_at": "2025-01-01T00:00:00Z",
      "grant_types": [
        "authorization_code",
        "refresh_token"
      ],
      "has_rotated_secret": false,
      "logo_uri": "https://example.com/logo.png",
      "policy_uri": "https://example.com/privacy",
      "post_logout_redirect_uris": [
        "https://example.com/logout"
      ],
      "promoted_at": "2026-05-13T12:00:00Z",
      "redirect_uris": [
        "https://example.com/callback"
      ],
      "response_types": [
        "code"
      ],
      "scopes": [
        "account.read"
      ],
      "token_endpoint_auth_method": "client_secret_post",
      "tos_uri": "https://example.com/tos",
      "updated_at": "2025-01-01T00:00:00Z"
    }
  ],
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}